#include "UART.h"

void initUART()
{
    uint16_t i = 0;

    //PPS:
    //UART1TX (out) -> RP9
    //UART1RX (in)  -> RP8
    uint8_t oscconl_u8;
    oscconl_u8 = OSCCONL;
    oscconl_u8 &= ~0x40;
    __builtin_write_OSCCONL(oscconl_u8);

    RPINR18bits.U1RXR = 0x08;
    RPOR4bits.RP9R = 0x03;
    
    oscconl_u8 = OSCCONL;
    oscconl_u8 |= 0x40;
    __builtin_write_OSCCONL( oscconl_u8 );

    //setup uart:
    U1MODEbits.USIDL = 0;   //no idle-mode
    U1MODEbits.IREN = 0;    //no ir
    U1MODEbits.UEN = 0;     //no flow-control
    U1MODEbits.PDSEL = 0;   //no parity
    U1MODEbits.STSEL = 0;   //one stop-bit

    U1MODEbits.RTSMD = 1;

    U1BRG = BRGVAL;         //baudrate

    //fire tx-interrupt when transmit buffer is empty
    U1STAbits.UTXISEL1 = 1;
    U1STAbits.UTXISEL0 = 0;

    //rx-interrupt when one character's been recieved
    U1STAbits.URXISEL1 = 0;

    U1STAbits.ADDEN = 0;    //no address detection

    //enable uart interrupts:
    IFS0bits.U1RXIF = 0;
    IEC0bits.U1RXIE = 1;

    IFS0bits.U1TXIF = 0;
    IEC0bits.U1TXIE = 1;
    
    U1MODEbits.UARTEN = 1;  //enable uart
    U1STAbits.UTXEN = 1;    //enable tx

    //wait before sending first data
    for(i = 0; i < 4160; i++)
    {
        Nop();
    }
}
