/* 
 * File:   constants.h
 * Author: philipp windischhofer
 *
 * Created on 3. August 2014, 16:18
 */

#ifndef CONSTANTS_H
#define	CONSTANTS_H

#define FCY 40000000
#define BAUDRATE 115200
#define BRGVAL ((FCY / BAUDRATE) / 16) - 1
#define INPUT_BUFFER_LENGTH     10
#define OUTPUT_BUFFER_LENGTH    20

#define SPECTRUM_LENGTH 4096
#define RESET_LINE      LATBbits.LATB1
#define TICKOUT_LINE    LATBbits.LATB12

//pulse-height state machine
#define SAMPLE      1
#define ARMED       2
#define ARMED_FIRST 3
#define WAIT_PULSE  4

//high level i2c-recieve state machine
#define ASCII_OFFSET        48
#define GET_CHANNEL         'c'
#define GET_ALL_CHANNELS    'C'
#define RESET_ALL_CHANNELS  'R'
#define GET_LAST_CNTS       'n'
#define RESET_LAST_CNTS     'r'
#define STOP_ACQ            's'
#define START_ACQ           'S'
#define GET_LAST_HEIGHT     'h'
#define GET_TIME            't'
#define CR                  0x0D
#define LF                  0x0A

#define ERROR               1
#define OK                  2
#define ON                  1
#define OFF                 2

//low level i2c-transmit state machine

#define TMR1_PRELOAD_VALUE 0xFF00

#endif	/* CONSTANTS_H */

